#include "Ogre.h" 
#include "SDL/SDL.h"
#include "SDL/SDL_mixer.h"
#include "OgreFrameListener.h" 
#include "OgreEventListeners.h" 
#include "OgreKeyEvent.h"

#include "chadplayer.h"

using namespace Ogre;

class CChadGame : public FrameListener, public MouseListener, public MouseMotionListener, public KeyListener {
public:
	CChadGame();
	~CChadGame();
	bool loadConfig();
	void initialise();
	int run();

	void createScene();

	// this function was getting a bit big, so I've moved it into chad.cpp
	bool frameStarted(const FrameEvent& evt);

	bool frameEnded(const FrameEvent& evt) { 
		return true; 
	}

	void mouseClicked(MouseEvent* e) { }
	void mouseEntered(MouseEvent* e) { }
	void mouseExited(MouseEvent* e)  { }

	void mousePressed(MouseEvent* e) { }
	void mouseReleased(MouseEvent* e) { }
	
	void mouseMoved(MouseEvent *e) {		m_Camera->yaw( Radian(-e->getRelX() * 1.0) );
		m_Camera->pitch( Radian(-e->getRelY() * 1.0) );
	}

	void mouseDragged(MouseEvent *e) {
		m_Camera->yaw( Radian(-e->getRelX() * 1.0) );
		m_Camera->pitch( Radian(-e->getRelY() * 1.0) );
	}

	void keyPressed(KeyEvent *e);
	void keyReleased(KeyEvent *e);
	void keyClicked(KeyEvent *e) { }

	Root* m_Ogre;
	EventProcessor* m_EventProcessor;
	InputReader* m_InputReader;

	SceneManager* m_SceneMgr;
	Camera* m_Camera;
	Viewport* m_Viewport;

	CChadPlayer* m_Player;

	SceneNode* OceanNode;
	double m_OceanFlowNum;
};
